#include<stdio.h>
#include<stdlib.h>
#include<time.h>

typedef int int_array_type[10];

void fill_array(int_array_type array)
{
    int i;
    srand(time(0));
    for(i=0;i<sizeof(int_array_type)/sizeof(array[0]);i++)
        array[i] = -10+rand()%21;
}

void print_array(int_array_type array)
{
    int i;
    for(i=0;i<sizeof(int_array_type)/sizeof(*array);i++)
        printf("%d ",array[i]);
    printf("\n");
}

void swap(int *first, int *second)
{
    int temporary = *first;
    *first = *second;
    *second = temporary;
}

int partition(int_array_type array, int low, int high)
{
    int pivot = array[low];
    int i = low-1, j = high+1;

    while(i<j) {
        while(array[--j]>pivot)
            ;
        while(array[++i]<pivot)
            ;
        if(i<j)
            swap(&array[i],&array[j]);
    }
    return j;
}

void quicksort(int_array_type array, int low, int high)
{
    if(low<high) {
        int partition_index = partition(array,low,high);
        quicksort(array, low, partition_index);
        quicksort(array, partition_index+1, high);
    }
}

int main(void)
{
    int_array_type array;
    fill_array(array);
    print_array(array);
    quicksort(array,0,sizeof(int_array_type)/sizeof(*array)-1);
    print_array(array);
    return 0;
}
